/* This file is part of Machina.
 * Copyright (C) 2007-2009 David Robillard <http://drobilla.net>
 *
 * Machina is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Machina is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Machina.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MACHINA_LOADER_HPP
#define MACHINA_LOADER_HPP

#include <glibmm/ustring.h>
#include "raul/SharedPtr.hpp"
#include "raul/Path.hpp"
#include "redlandmm/World.hpp"

using Redland::Namespaces;

namespace Machina {

class Machine;


class Loader {
public:
	Loader(Redland::World& rdf_world);

	SharedPtr<Machine> load(const Glib::ustring& filename);

private:
	Redland::World& _rdf_world;
};


} // namespace Machina

#endif // MACHINA_LOADER_HPP
