/* This file is part of Machina.
 * Copyright (C) 2007-2009 David Robillard <http://drobilla.net>
 *
 * Machina is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Machina is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Machina.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MACHINA_MACHINE_MUTATION_HPP
#define MACHINA_MACHINE_MUTATION_HPP

#include "machina-config.h"

#ifdef HAVE_EUGENE
	#include "eugene/Mutation.hpp"
	#define SUPER : public Eugene::Mutation<Machine>
#else
	#define SUPER : public Mutation
#endif

namespace Machina {

class Machine;

namespace Mutation {

struct Mutation { virtual ~Mutation() {}; virtual void mutate(Machine& machine) = 0; };

struct Compress   SUPER { void mutate(Machine& machine); };
struct AddNode    SUPER { void mutate(Machine& machine); };
struct RemoveNode SUPER { void mutate(Machine& machine); };
struct AdjustNode SUPER { void mutate(Machine& machine); };
struct SwapNodes  SUPER { void mutate(Machine& machine); };
struct AddEdge    SUPER { void mutate(Machine& machine); };
struct RemoveEdge SUPER { void mutate(Machine& machine); };
struct AdjustEdge SUPER { void mutate(Machine& machine); };

} // namespace Mutation

} // namespace Machina

#endif // MACHINA_MACHINE_MUTATION_HPP
